/// <reference types="node" />
import { ZoneId } from 'js-joda';
import * as CS from './character-sets';
import { VR } from './vr';
export declare const indeterminateLength = 4294967295;
export declare const zero4Bytes: Buffer;
export declare function concat(a: Buffer, b: Buffer): Buffer;
export declare function concatv(...buffers: Buffer[]): Buffer;
export declare function flatten<T>(array: T[][]): T[];
export declare function appendToArray<T>(object: T, array: T[]): T[];
export declare function prependToArray<T>(object: T, array: T[]): T[];
export declare function concatArrays<T>(array1: T[], array2: T[]): T[];
export declare function hexToDec(s: string): string;
export declare function toUID(root: string, uuid: string): string;
export declare function nameBasedUID(name: string, root: string): string;
export declare function randomUID(root: string): string;
export declare const multiValueDelimiter = "\\";
export declare const emptyBuffer: Buffer;
export declare function toUInt32(num: number): number;
export declare function toInt32(num: number): number;
export declare function shiftLeftUnsigned(num: number, n: number): number;
export declare function groupNumber(tag: number): number;
export declare function elementNumber(tag: number): number;
export declare function bytesToShortBE(bytes: Buffer): number;
export declare function bytesToShortLE(bytes: Buffer): number;
export declare function bytesToShort(bytes: Buffer, bigEndian?: boolean): number;
export declare function bytesToUShortBE(bytes: Buffer): number;
export declare function bytesToUShortLE(bytes: Buffer): number;
export declare function bytesToUShort(bytes: Buffer, bigEndian?: boolean): number;
export declare function bytesToVR(bytes: Buffer): number;
export declare function bytesToIntBE(bytes: Buffer): number;
export declare function bytesToIntLE(bytes: Buffer): number;
export declare function bytesToInt(bytes: Buffer, bigEndian?: boolean): number;
export declare function bytesToUIntBE(bytes: Buffer): number;
export declare function bytesToUIntLE(bytes: Buffer): number;
export declare function bytesToUInt(bytes: Buffer, bigEndian?: boolean): number;
export declare function bytesToTagBE(bytes: Buffer): number;
export declare function bytesToTagLE(bytes: Buffer): number;
export declare function bytesToTag(bytes: Buffer, bigEndian?: boolean): number;
export declare function bytesToFloatBE(bytes: Buffer): number;
export declare function bytesToFloatLE(bytes: Buffer): number;
export declare function bytesToFloat(bytes: Buffer, bigEndian?: boolean): number;
export declare function bytesToDoubleBE(bytes: Buffer): number;
export declare function bytesToDoubleLE(bytes: Buffer): number;
export declare function bytesToDouble(bytes: Buffer, bigEndian?: boolean): number;
export declare function intToBytesBE(i: number): Buffer;
export declare function intToBytesLE(i: number): Buffer;
export declare function shortToBytesBE(i: number): Buffer;
export declare function shortToBytesLE(i: number): Buffer;
export declare function shortToBytes(i: number, bigEndian?: boolean): Buffer;
export declare function intToBytes(i: number, bigEndian?: boolean): Buffer;
export declare function tagToBytesBE(tag: number): Buffer;
export declare function tagToBytesLE(tag: number): Buffer;
export declare function tagToBytes(tag: number, bigEndian?: boolean): Buffer;
export declare function floatToBytes(f: number, bigEndian?: boolean): Buffer;
export declare function doubleToBytes(f: number, bigEndian?: boolean): Buffer;
export declare function tagToString(tag: number): string;
export declare function trim(s: string): string;
export declare function padToEvenLength(bytes: Buffer, tagOrVR: number | VR): Buffer;
export declare const itemLE: Buffer;
export declare const itemBE: Buffer;
export declare function item(length?: number, bigEndian?: boolean): Buffer;
export declare const itemDelimitationLE: Buffer;
export declare const itemDelimitationBE: Buffer;
export declare function itemDelimitation(bigEndian?: boolean): Buffer;
export declare const sequenceDelimitationLE: Buffer;
export declare const sequenceDelimitationBE: Buffer;
export declare function sequenceDelimitation(bigEndian?: boolean): Buffer;
export declare function sequenceDelimitationNonZeroLength(bigEndian?: boolean): Buffer;
export declare function isFileMetaInformation(tag: number): boolean;
export declare function isGroupLength(tag: number): boolean;
export declare function isDeflated(transferSyntaxUid: string): boolean;
export declare const systemZone: ZoneId;
export declare const defaultCharacterSet: CS.CharacterSets;
export declare function createUID(): string;
export declare function createUIDFromRoot(root: string): string;
export declare function createNameBasedUID(name: string): string;
export declare function createNameBasedUIDFromRoot(name: string, root: string): string;
export declare function pipe(...streams: any[]): any;
