"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.tagToBytes = exports.tagToBytesLE = exports.tagToBytesBE = exports.intToBytes = exports.shortToBytes = exports.shortToBytesLE = exports.shortToBytesBE = exports.intToBytesLE = exports.intToBytesBE = exports.bytesToDouble = exports.bytesToDoubleLE = exports.bytesToDoubleBE = exports.bytesToFloat = exports.bytesToFloatLE = exports.bytesToFloatBE = exports.bytesToTag = exports.bytesToTagLE = exports.bytesToTagBE = exports.bytesToUInt = exports.bytesToUIntLE = exports.bytesToUIntBE = exports.bytesToInt = exports.bytesToIntLE = exports.bytesToIntBE = exports.bytesToVR = exports.bytesToUShort = exports.bytesToUShortLE = exports.bytesToUShortBE = exports.bytesToShort = exports.bytesToShortLE = exports.bytesToShortBE = exports.elementNumber = exports.groupNumber = exports.shiftLeftUnsigned = exports.toInt32 = exports.toUInt32 = exports.emptyBuffer = exports.multiValueDelimiter = exports.randomUID = exports.nameBasedUID = exports.toUID = exports.hexToDec = exports.concatArrays = exports.prependToArray = exports.appendToArray = exports.flatten = exports.concatv = exports.concat = exports.zero4Bytes = exports.indeterminateLength = void 0;
exports.pipe = exports.createNameBasedUIDFromRoot = exports.createNameBasedUID = exports.createUIDFromRoot = exports.createUID = exports.defaultCharacterSet = exports.systemZone = exports.isDeflated = exports.isGroupLength = exports.isFileMetaInformation = exports.sequenceDelimitationNonZeroLength = exports.sequenceDelimitation = exports.sequenceDelimitationBE = exports.sequenceDelimitationLE = exports.itemDelimitation = exports.itemDelimitationBE = exports.itemDelimitationLE = exports.item = exports.itemBE = exports.itemLE = exports.padToEvenLength = exports.trim = exports.tagToString = exports.doubleToBytes = exports.floatToBytes = void 0;
const js_joda_1 = require("js-joda");
const multipipe_1 = __importDefault(require("multipipe"));
const uuid_1 = require("uuid");
const CS = __importStar(require("./character-sets"));
const lookup_1 = require("./lookup");
const tag_1 = require("./tag");
const uid_1 = require("./uid");
// eslint:disable: no-bitwise
exports.indeterminateLength = 0xffffffff;
exports.zero4Bytes = Buffer.from([0, 0, 0, 0]);
function concat(a, b) {
    return Buffer.concat([a, b], a.length + b.length);
}
exports.concat = concat;
function concatv(...buffers) {
    return Buffer.concat(buffers);
}
exports.concatv = concatv;
function flatten(array) {
    return [].concat(...array);
}
exports.flatten = flatten;
function appendToArray(object, array) {
    const newArray = array.slice();
    newArray.push(object);
    return newArray;
}
exports.appendToArray = appendToArray;
function prependToArray(object, array) {
    const newArray = array.slice();
    newArray.unshift(object);
    return newArray;
}
exports.prependToArray = prependToArray;
function concatArrays(array1, array2) {
    const newArray = array1.slice();
    array2.forEach((i) => newArray.push(i));
    return newArray;
}
exports.concatArrays = concatArrays;
const uidRoot = '2.25';
const uuidNamespace = 'd181d67b-0a1c-45bf-8616-070f1bb0d0cf';
function hexToDec(s) {
    const digits = [0];
    let carry;
    for (let i = 0; i < s.length; i++) {
        carry = parseInt(s.charAt(i), 16);
        for (let j = 0; j < digits.length; j++) {
            digits[j] = digits[j] * 16 + carry;
            carry = (digits[j] / 10) | 0;
            digits[j] %= 10;
        }
        while (carry > 0) {
            digits.push(carry % 10);
            carry = (carry / 10) | 0;
        }
    }
    return digits.reverse().join('');
}
exports.hexToDec = hexToDec;
function toUID(root, uuid) {
    const hexStr = uuid.replace(/-/g, '');
    const docStr = hexToDec(hexStr).replace(/^0+/, '');
    return (root + '.' + docStr).substring(0, 64);
}
exports.toUID = toUID;
function nameBasedUID(name, root) {
    return toUID(root, (0, uuid_1.v5)(name, uuidNamespace));
}
exports.nameBasedUID = nameBasedUID;
function randomUID(root) {
    return toUID(root, (0, uuid_1.v4)());
}
exports.randomUID = randomUID;
exports.multiValueDelimiter = '\\';
exports.emptyBuffer = Buffer.alloc(0);
function toUInt32(num) {
    return num >>> 0;
}
exports.toUInt32 = toUInt32;
function toInt32(num) {
    return num >> 0;
}
exports.toInt32 = toInt32;
function shiftLeftUnsigned(num, n) {
    return toUInt32(num << n);
}
exports.shiftLeftUnsigned = shiftLeftUnsigned;
function groupNumber(tag) {
    return tag >>> 16;
}
exports.groupNumber = groupNumber;
function elementNumber(tag) {
    return tag & 0xffff;
}
exports.elementNumber = elementNumber;
function bytesToShortBE(bytes) {
    return bytes.readInt16BE(0);
}
exports.bytesToShortBE = bytesToShortBE;
function bytesToShortLE(bytes) {
    return bytes.readInt16LE(0);
}
exports.bytesToShortLE = bytesToShortLE;
function bytesToShort(bytes, bigEndian = false) {
    return bigEndian ? bytesToShortBE(bytes) : bytesToShortLE(bytes);
}
exports.bytesToShort = bytesToShort;
function bytesToUShortBE(bytes) {
    return bytes.readUInt16BE(0);
}
exports.bytesToUShortBE = bytesToUShortBE;
function bytesToUShortLE(bytes) {
    return bytes.readUInt16LE(0);
}
exports.bytesToUShortLE = bytesToUShortLE;
function bytesToUShort(bytes, bigEndian = false) {
    return bigEndian ? bytesToUShortBE(bytes) : bytesToUShortLE(bytes);
}
exports.bytesToUShort = bytesToUShort;
function bytesToVR(bytes) {
    return bytesToUShortBE(bytes);
}
exports.bytesToVR = bytesToVR;
function bytesToIntBE(bytes) {
    return bytes.readInt32BE(0);
}
exports.bytesToIntBE = bytesToIntBE;
function bytesToIntLE(bytes) {
    return bytes.readInt32LE(0);
}
exports.bytesToIntLE = bytesToIntLE;
function bytesToInt(bytes, bigEndian = false) {
    return bigEndian ? bytesToIntBE(bytes) : bytesToIntLE(bytes);
}
exports.bytesToInt = bytesToInt;
function bytesToUIntBE(bytes) {
    return bytes.readUInt32BE(0);
}
exports.bytesToUIntBE = bytesToUIntBE;
function bytesToUIntLE(bytes) {
    return bytes.readUInt32LE(0);
}
exports.bytesToUIntLE = bytesToUIntLE;
function bytesToUInt(bytes, bigEndian = false) {
    return bigEndian ? bytesToUIntBE(bytes) : bytesToUIntLE(bytes);
}
exports.bytesToUInt = bytesToUInt;
function bytesToTagBE(bytes) {
    return bytesToUIntBE(bytes);
}
exports.bytesToTagBE = bytesToTagBE;
function bytesToTagLE(bytes) {
    return shiftLeftUnsigned(bytes.readUInt16LE(0), 16) + bytes.readUInt16LE(2);
}
exports.bytesToTagLE = bytesToTagLE;
function bytesToTag(bytes, bigEndian = false) {
    return bigEndian ? bytesToTagBE(bytes) : bytesToTagLE(bytes);
}
exports.bytesToTag = bytesToTag;
function bytesToFloatBE(bytes) {
    return bytes.readFloatBE(0);
}
exports.bytesToFloatBE = bytesToFloatBE;
function bytesToFloatLE(bytes) {
    return bytes.readFloatLE(0);
}
exports.bytesToFloatLE = bytesToFloatLE;
function bytesToFloat(bytes, bigEndian = false) {
    return bigEndian ? bytesToFloatBE(bytes) : bytesToFloatLE(bytes);
}
exports.bytesToFloat = bytesToFloat;
function bytesToDoubleBE(bytes) {
    return bytes.readDoubleBE(0);
}
exports.bytesToDoubleBE = bytesToDoubleBE;
function bytesToDoubleLE(bytes) {
    return bytes.readDoubleLE(0);
}
exports.bytesToDoubleLE = bytesToDoubleLE;
function bytesToDouble(bytes, bigEndian = false) {
    return bigEndian ? bytesToDoubleBE(bytes) : bytesToDoubleLE(bytes);
}
exports.bytesToDouble = bytesToDouble;
function intToBytesBE(i) {
    return Buffer.from([i >> 24, i >> 16, i >> 8, i]);
}
exports.intToBytesBE = intToBytesBE;
function intToBytesLE(i) {
    return Buffer.from([i, i >> 8, i >> 16, i >> 24]);
}
exports.intToBytesLE = intToBytesLE;
function shortToBytesBE(i) {
    return Buffer.from([i >> 8, i]);
}
exports.shortToBytesBE = shortToBytesBE;
function shortToBytesLE(i) {
    return Buffer.from([i, i >> 8]);
}
exports.shortToBytesLE = shortToBytesLE;
function shortToBytes(i, bigEndian = false) {
    return bigEndian ? shortToBytesBE(i) : shortToBytesLE(i);
}
exports.shortToBytes = shortToBytes;
function intToBytes(i, bigEndian = false) {
    return bigEndian ? intToBytesBE(i) : intToBytesLE(i);
}
exports.intToBytes = intToBytes;
function tagToBytesBE(tag) {
    return intToBytesBE(tag);
}
exports.tagToBytesBE = tagToBytesBE;
function tagToBytesLE(tag) {
    return Buffer.from([tag >> 16, tag >> 24, tag, tag >> 8]);
}
exports.tagToBytesLE = tagToBytesLE;
function tagToBytes(tag, bigEndian = false) {
    return bigEndian ? tagToBytesBE(tag) : tagToBytesLE(tag);
}
exports.tagToBytes = tagToBytes;
function floatToBytes(f, bigEndian = false) {
    const buf = Buffer.allocUnsafe(4);
    if (bigEndian) {
        buf.writeFloatBE(f, 0);
    }
    else {
        buf.writeFloatLE(f, 0);
    }
    return buf;
}
exports.floatToBytes = floatToBytes;
function doubleToBytes(f, bigEndian = false) {
    const buf = Buffer.allocUnsafe(8);
    if (bigEndian) {
        buf.writeDoubleBE(f, 0);
    }
    else {
        buf.writeDoubleLE(f, 0);
    }
    return buf;
}
exports.doubleToBytes = doubleToBytes;
function tagToString(tag) {
    const hex = ('00000000' + tag.toString(16)).slice(-8);
    return '(' + hex.slice(0, 4) + ',' + hex.slice(4, 8) + ')';
}
exports.tagToString = tagToString;
function trim(s) {
    return s.replace(/^[\x00-\x20]*/g, '').replace(/[\x00-\x20]*$/g, '');
}
exports.trim = trim;
function padToEvenLength(bytes, tagOrVR) {
    const vr = isNaN(tagOrVR) ? tagOrVR : lookup_1.Lookup.vrOf(tagOrVR);
    return (bytes.length & 1) !== 0 ? concat(bytes, Buffer.from([vr.paddingByte])) : bytes;
}
exports.padToEvenLength = padToEvenLength;
exports.itemLE = concat(tagToBytesLE(tag_1.Tag.Item), intToBytesLE(exports.indeterminateLength));
exports.itemBE = concat(tagToBytesBE(tag_1.Tag.Item), intToBytesBE(exports.indeterminateLength));
function item(length = exports.indeterminateLength, bigEndian = false) {
    return length === exports.indeterminateLength
        ? bigEndian
            ? exports.itemBE
            : exports.itemLE
        : concat(tagToBytes(tag_1.Tag.Item, bigEndian), intToBytes(length, bigEndian));
}
exports.item = item;
exports.itemDelimitationLE = concat(tagToBytesLE(tag_1.Tag.ItemDelimitationItem), exports.zero4Bytes);
exports.itemDelimitationBE = concat(tagToBytesBE(tag_1.Tag.ItemDelimitationItem), exports.zero4Bytes);
function itemDelimitation(bigEndian = false) {
    return bigEndian ? exports.itemDelimitationBE : exports.itemDelimitationLE;
}
exports.itemDelimitation = itemDelimitation;
exports.sequenceDelimitationLE = concat(tagToBytesLE(tag_1.Tag.SequenceDelimitationItem), exports.zero4Bytes);
exports.sequenceDelimitationBE = concat(tagToBytesBE(tag_1.Tag.SequenceDelimitationItem), exports.zero4Bytes);
function sequenceDelimitation(bigEndian = false) {
    return bigEndian ? exports.sequenceDelimitationBE : exports.sequenceDelimitationLE;
}
exports.sequenceDelimitation = sequenceDelimitation;
function sequenceDelimitationNonZeroLength(bigEndian = false) {
    return concatv(tagToBytes(tag_1.Tag.SequenceDelimitationItem, bigEndian), intToBytes(0x00000010, bigEndian));
}
exports.sequenceDelimitationNonZeroLength = sequenceDelimitationNonZeroLength;
function isFileMetaInformation(tag) {
    return (tag & 0xffff0000) === 0x00020000;
}
exports.isFileMetaInformation = isFileMetaInformation;
function isGroupLength(tag) {
    return elementNumber(tag) === 0;
}
exports.isGroupLength = isGroupLength;
function isDeflated(transferSyntaxUid) {
    return transferSyntaxUid === uid_1.UID.DeflatedExplicitVRLittleEndian || transferSyntaxUid === uid_1.UID.JPIPReferencedDeflate;
}
exports.isDeflated = isDeflated;
exports.systemZone = js_joda_1.ZoneId.SYSTEM;
exports.defaultCharacterSet = CS.defaultCharacterSet;
function createUID() {
    return randomUID(uidRoot);
}
exports.createUID = createUID;
function createUIDFromRoot(root) {
    return randomUID(root);
}
exports.createUIDFromRoot = createUIDFromRoot;
function createNameBasedUID(name) {
    return nameBasedUID(name, uidRoot);
}
exports.createNameBasedUID = createNameBasedUID;
function createNameBasedUIDFromRoot(name, root) {
    return nameBasedUID(name, root);
}
exports.createNameBasedUIDFromRoot = createNameBasedUIDFromRoot;
function pipe(...streams) {
    return (0, multipipe_1.default)(streams);
}
exports.pipe = pipe;
//# sourceMappingURL=base.js.map