/// <reference types="node" />
export interface ByteParserTarget {
    next(result: any): void;
    fail(error?: any): void;
    complete(): void;
}
export declare abstract class ParseStep {
    abstract parse(reader: ByteReader): ParseResult;
    onTruncation(reader: ByteReader): void;
}
declare class FinishedParser extends ParseStep {
    parse(): ParseResult;
}
export declare const finishedParser: FinishedParser;
export declare class ParseResult {
    result: any;
    nextStep: ParseStep;
    constructor(result: any, nextStep: ParseStep);
}
export declare class ByteReader {
    private input;
    private off;
    constructor(input: Buffer);
    setInput(input: Buffer): void;
    hasRemaining(): boolean;
    remainingSize(): number;
    remainingData(): Buffer;
    ensure(n: number): void;
    take(n: number): Buffer;
}
export declare class ByteParser {
    readonly out: ByteParserTarget;
    current: ParseStep;
    isCompleted: boolean;
    hasData: boolean;
    private reader;
    private buffer;
    constructor(out: ByteParserTarget);
    parse(chunk: any): void;
    flush(): void;
    startWith(step: ParseStep): void;
    protected complete(): void;
    protected fail(error?: any): void;
    private doParseInner;
    private doParse;
}
export {};
