/// <reference types="node" />
import { Transform } from 'stream';
import { Detour } from './detour';
import { DicomPart, HeaderPart } from './dicom-parts';
import { TagPath } from './tag-path';
import { TagTree } from './tag-tree';
export declare function toBytesFlow(): Transform;
export declare function stopTagFlow(tag: number): any;
export declare function tagFilter(keepCondition: (t: TagPath) => boolean, defaultCondition?: (p: DicomPart) => boolean, logGroupLengthWarnings?: boolean): any;
export declare function allowFilter(allowlist: TagTree[], defaultCondition?: (p: DicomPart) => boolean, logGroupLengthWarnings?: boolean): any;
export declare function denyFilter(denylist: TagTree[], defaultCondition?: (p: DicomPart) => boolean, logGroupLengthWarnings?: boolean): any;
export declare function groupLengthDiscardFilter(): any;
export declare function fmiDiscardFilter(): any;
export declare function headerFilter(keepCondition: (p: HeaderPart) => boolean, logGroupLengthWarnings?: boolean): any;
export declare class ValidationContext {
    readonly sopClassUID: string;
    readonly transferSyntaxUID: string;
    constructor(sopClassUID: string, transferSyntaxUID: string);
}
export declare function validateContextFlow(contexts: ValidationContext[]): any;
export declare function fmiGroupLengthFlow(): any;
export declare function toIndeterminateLengthSequences(): any;
export declare function toUtf8Flow(): any;
declare class DeflateDatasetFlow extends Detour {
    private collectingTs;
    private tsBytes;
    constructor();
    process(part: DicomPart): void;
}
export declare function deflateDatasetFlow(): DeflateDatasetFlow;
export {};
