"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.elementSink = void 0;
const stream_1 = require("stream");
const elements_builder_1 = require("./elements-builder");
function elementSink(callback) {
    const builder = new elements_builder_1.ElementsBuilder();
    const sink = new stream_1.Writable({
        objectMode: true,
        write(element, encoding, cb) {
            try {
                builder.addElement(element);
                process.nextTick(() => cb());
            }
            catch (error) {
                process.nextTick(() => this.emit('error', error));
            }
        },
    });
    sink.once('finish', () => {
        callback(builder.build());
    });
    return sink;
}
exports.elementSink = elementSink;
//# sourceMappingURL=element-sink.js.map