"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Lookup = void 0;
const tag_1 = require("./tag");
const tag_to_vr_1 = require("./tag-to-vr");
const uid_to_name_1 = require("./uid-to-name");
class Lookup {
    static keywordOf(tag) {
        if ((tag & 0x0000ffff) === 0 && (tag & 0xfffd0000) !== 0) {
            return 'GroupLength';
        }
        if ((tag & 0x00010000) !== 0) {
            if ((tag & 0x0000ff00) === 0 && (tag & 0x000000f0) !== 0) {
                return 'PrivateCreatorID';
            }
            return '';
        }
        if ((tag & 0xffffff00) === tag_1.Tag.SourceImageIDs) {
            return 'SourceImageIDs';
        }
        let tag2 = tag;
        if ((tag & 0xffe00000) === 0x50000000 || (tag & 0xffe00000) === 0x60000000) {
            tag2 = tag & 0xffe0ffff;
        }
        else if ((tag & 0xff000000) === 0x7f000000 && (tag & 0xffff0000) !== 0x7fe00000) {
            tag2 = tag & 0xff00ffff;
        }
        return Lookup.keywords.find((key) => tag_1.Tag[key] === tag2);
    }
    static vrOf(tag) {
        return tag_to_vr_1.TagToVR.vrOf(tag);
    }
    static tagOf(keyword) {
        return tag_1.Tag[keyword];
    }
    static nameOf(uid) {
        return uid_to_name_1.UIDToName.nameOf(uid);
    }
}
Lookup.keywords = Object.keys(tag_1.Tag);
exports.Lookup = Lookup;
//# sourceMappingURL=lookup.js.map