/// <reference types="node" />
import { MetaPart } from './dicom-parts';
import { TagPath } from './tag-path';
export declare class TagModification {
    readonly matches: (t: TagPath) => boolean;
    readonly modification: (b: Buffer) => Buffer;
    static equals(tagPath: TagPath, modification: (b: Buffer) => Buffer): TagModification;
    static endsWith(tagPath: TagPath, modification: (b: Buffer) => Buffer): TagModification;
    constructor(matches: (t: TagPath) => boolean, modification: (b: Buffer) => Buffer);
}
export declare class TagInsertion {
    readonly tagPath: TagPath;
    readonly insertion: (b: Buffer) => Buffer;
    constructor(tagPath: TagPath, insertion: (b: Buffer) => Buffer);
}
export declare class TagModificationsPart extends MetaPart {
    readonly modifications: TagModification[];
    readonly insertions: TagInsertion[];
    readonly replace: boolean;
    constructor(modifications?: TagModification[], insertions?: TagInsertion[], replace?: boolean);
}
export declare function modifyFlow(modifications?: TagModification[], insertions?: TagInsertion[], logGroupLengthWarnings?: boolean): any;
