import { ByteParser } from './byte-parser';
import { Detour } from './detour';
declare class ParseFlow extends Detour {
    readonly chunkSize: number;
    readonly inflate: boolean;
    readonly bufferBytes: number;
    parser: ByteParser;
    constructor(chunkSize?: number, inflate?: boolean, bufferBytes?: number);
    /**
     * Overrides process in Detour. Process a chunk of binary data.
     */
    process(chunk: any): void;
    /**
     * Overrides cleanup in Detour. If there are unparsed bytes left, try to parse these, or fail.
     */
    cleanup(): void;
    /**
     * Called by byte parser when it is emitting the next parsed element
     */
    next(part: any): void;
    /**
     * Called by byte parser when completing parser. Here we signal completion to the stream.
     */
    complete(): void;
    /**
     * Called by byte parser on error. Here we signal error to the stream.
     */
    fail(error?: any): void;
}
export declare function parseFlow(chunkSize?: number, inflate?: boolean, bufferBytes?: number): ParseFlow;
export {};
