/// <reference types="node" />
import { ByteReader } from './byte-parser';
import { VR } from './vr';
export declare const dicomPreambleLength = 132;
export declare function isDICM(bytes: Buffer): boolean;
export declare class HeaderInfo {
    readonly bigEndian: boolean;
    readonly explicitVR: boolean;
    readonly hasFmi: boolean;
    constructor(bigEndian: boolean, explicitVR: boolean, hasFmi: boolean);
}
export declare function tryReadHeader(data: Buffer): HeaderInfo;
export declare function headerInfo(data: Buffer, assumeBigEndian: boolean): HeaderInfo;
export declare function isPreamble(data: Buffer): boolean;
export declare class TagVr {
    readonly tag: number;
    readonly vr: VR;
    constructor(tag: number, vr: VR);
}
export declare function isSpecial(tag: number): boolean;
export declare function readTagVr(data: Buffer, bigEndian: boolean, explicitVr: boolean): TagVr;
export declare class AttributeInfo {
    readonly tag: number;
    readonly vr: VR;
    readonly headerLength: number;
    readonly valueLength: number;
    constructor(tag: number, vr: VR, headerLength: number, valueLength: number);
}
export declare function readHeader(reader: ByteReader, state: any): AttributeInfo;
export declare function warnIfOdd(tag: number, vr: VR, valueLength: number): void;
