"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PersonName = exports.ComponentGroup = void 0;
const value_1 = require("./value");
const base_1 = require("./base");
class ComponentGroup {
    constructor(alphabetic, ideographic = '', phonetic = '') {
        this.alphabetic = alphabetic;
        this.ideographic = ideographic;
        this.phonetic = phonetic;
    }
}
exports.ComponentGroup = ComponentGroup;
class PersonName {
    constructor(familyName, givenName, middleName = new ComponentGroup(''), prefix = new ComponentGroup(''), suffix = new ComponentGroup('')) {
        this.familyName = familyName;
        this.givenName = givenName;
        this.middleName = middleName;
        this.prefix = prefix;
        this.suffix = suffix;
    }
    static parse(s) {
        return s
            .split(base_1.multiValueDelimiter)
            .map(base_1.trim)
            .map((s1) => (0, value_1.parsePersonName)(s1));
    }
    toString() {
        const components = [this.familyName, this.givenName, this.middleName, this.prefix, this.suffix];
        const representations = ['alphabetic', 'ideographic', 'phonetic'];
        return representations
            .map((repr) => {
            return components
                .map((c) => c[repr])
                .join('^')
                .replace(/\^+$/, ''); // Trim trailing ^ separators
        })
            .join('=')
            .replace(/=+$/, ''); // Trim trailing = separators
    }
}
exports.PersonName = PersonName;
//# sourceMappingURL=person-name.js.map