"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TagPathLike = void 0;
class TagPathLike {
    isRoot() {
        return this.previous().isEmpty();
    }
    toList() {
        const toListRec = (path, list) => {
            if (!path.isRoot()) {
                toListRec(path.previous(), list);
            }
            list.push(path);
            return list;
        };
        return toListRec(this, []);
    }
    contains(tag) {
        return (this.toList()
            .map((tp) => tp.tag())
            .indexOf(tag) >= 0);
    }
    depth() {
        const depthRec = (path, d) => {
            if (path.isRoot()) {
                return d;
            }
            else {
                return depthRec(path.previous(), d + 1);
            }
        };
        return this.isEmpty() ? 0 : depthRec(this, 1);
    }
    head() {
        return this.take(1);
    }
    tail() {
        return this.drop(1);
    }
    take(n) {
        const takeRec = (path, i) => {
            return i <= 0 ? path : takeRec(path.previous(), i - 1);
        };
        return takeRec(this, this.depth() - n);
    }
}
exports.TagPathLike = TagPathLike;
//# sourceMappingURL=tag-path-like.js.map