import { TagPathLike } from './tag-path-like';
export declare class TagPath extends TagPathLike<TagPath> {
    static fromTag(tag: number): TagPathTag;
    static fromSequence(tag: number): TagPathSequence;
    static fromSequenceEnd(tag: number): TagPathSequenceEnd;
    static fromItem(tag: number, item: number): TagPathItem;
    static fromItemEnd(tag: number, item: number): TagPathItemEnd;
    static parse(s: string): TagPath;
    private tagVal;
    private previousVal;
    constructor(tag: number, previous: TagPathTrunk);
    tag(): number;
    previous(): TagPathTrunk;
    isEmpty(): boolean;
    isBelow(that: TagPath): boolean;
    isEqualTo(that: TagPath): boolean;
    startsWith(that: TagPath): boolean;
    endsWith(that: TagPath): boolean;
    drop(n: number): TagPath;
    toNamedString(lookup: boolean): string;
}
interface ItemIndex {
    item: number;
}
export declare class TagPathTrunk extends TagPath {
    thenTag(tag: number): TagPathTag;
    thenSequence(tag: number): TagPathSequence;
    thenSequenceEnd(tag: number): TagPathSequenceEnd;
    thenItem(tag: number, item: number): TagPathItem;
    thenItemEnd(tag: number, item: number): TagPathItemEnd;
}
declare class EmptyTagPath extends TagPathTrunk {
    tag(): number;
    previous(): TagPathTrunk;
}
export declare const emptyTagPath: EmptyTagPath;
export declare class TagPathTag extends TagPath {
    constructor(tag: number, previous: TagPathTrunk);
}
export declare class TagPathSequence extends TagPath {
    constructor(tag: number, previous: TagPathTrunk);
}
export declare class TagPathSequenceEnd extends TagPath {
    constructor(tag: number, previous: TagPathTrunk);
}
export declare class TagPathItem extends TagPathTrunk implements ItemIndex {
    readonly item: number;
    constructor(tag: number, item: number, previous: TagPathTrunk);
}
export declare class TagPathItemEnd extends TagPathTrunk implements ItemIndex {
    readonly item: number;
    constructor(tag: number, item: number, previous: TagPathTrunk);
}
export {};
