import { TagPath } from './tag-path';
import { TagPathLike } from './tag-path-like';
export declare class TagTree extends TagPathLike<TagTree> {
    static fromTag(tag: number): TagTreeTag;
    static fromAnyItem(tag: number): TagTreeAnyItem;
    static fromItem(tag: number, item: number): TagTreeItem;
    static fromPath(tagPath: TagPath): TagTree;
    static parse(str: string): TagTree;
    private tagVal;
    private previousVal;
    constructor(tag: number, previous: TagTreeTrunk);
    tag(): number;
    previous(): TagTreeTrunk;
    isEmpty(): boolean;
    isEqualTo(that: TagTree): boolean;
    isPath(): boolean;
    hasPath(tagPath: TagPath): boolean;
    hasTrunk(tagPath: TagPath): boolean;
    isTrunkOf(tagPath: TagPath): boolean;
    hasTwig(tagPath: TagPath): boolean;
    drop(n: number): TagTree;
    toNamedString(lookup: boolean): string;
}
export declare class TagTreeTrunk extends TagTree {
    thenTag(tag: number): TagTreeTag;
    thenAnyItem(tag: number): TagTreeAnyItem;
    thenItem(tag: number, item: number): TagTreeItem;
}
declare class EmptyTagTree extends TagTreeTrunk {
    tag(): number;
    previous(): TagTreeTrunk;
}
export declare const emptyTagTree: EmptyTagTree;
export declare class TagTreeTag extends TagTree {
    constructor(tag: number, previous: TagTreeTrunk);
}
export declare class TagTreeAnyItem extends TagTreeTrunk {
    constructor(tag: number, previous: TagTreeTrunk);
}
export declare class TagTreeItem extends TagTreeTrunk {
    readonly item: number;
    constructor(tag: number, item: number, previous: TagTreeTrunk);
}
export {};
