"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.VR = void 0;
class VR {
    static valueOf(code) {
        return VR.map.get(code);
    }
    constructor(name, code, headerLength, paddingByte) {
        this.name = name;
        this.code = code;
        this.headerLength = headerLength;
        this.paddingByte = paddingByte;
    }
}
VR.AE = new VR('AE', 0x4145, 8, 0x20);
VR.AS = new VR('AS', 0x4153, 8, 0x20);
VR.AT = new VR('AT', 0x4154, 8, 0);
VR.CS = new VR('CS', 0x4353, 8, 0x20);
VR.DA = new VR('DA', 0x4441, 8, 0x20);
VR.DS = new VR('DS', 0x4453, 8, 0x20);
VR.DT = new VR('DT', 0x4454, 8, 0x20);
VR.FD = new VR('FD', 0x4644, 8, 0);
VR.FL = new VR('FL', 0x464c, 8, 0);
VR.IS = new VR('IS', 0x4953, 8, 0x20);
VR.LO = new VR('LO', 0x4c4f, 8, 0x20);
VR.LT = new VR('LT', 0x4c54, 8, 0x20);
VR.OB = new VR('OB', 0x4f42, 12, 0);
VR.OD = new VR('OD', 0x4f44, 12, 0);
VR.OF = new VR('OF', 0x4f46, 12, 0);
VR.OL = new VR('OL', 0x4f4c, 12, 0);
VR.OV = new VR('OV', 0x4f56, 12, 0);
VR.OW = new VR('OW', 0x4f57, 12, 0);
VR.PN = new VR('PN', 0x504e, 8, 0x20);
VR.SH = new VR('SH', 0x5348, 8, 0x20);
VR.SL = new VR('SL', 0x534c, 8, 0);
VR.SQ = new VR('SQ', 0x5351, 12, 0);
VR.SS = new VR('SS', 0x5353, 8, 0);
VR.ST = new VR('ST', 0x5354, 8, 0x20);
VR.SV = new VR('SV', 0x5356, 12, 0);
VR.TM = new VR('TM', 0x544d, 8, 0x20);
VR.UC = new VR('UC', 0x5543, 12, 0x20);
VR.UI = new VR('UI', 0x5549, 8, 0);
VR.UL = new VR('UL', 0x554c, 8, 0);
VR.UN = new VR('UN', 0x554e, 12, 0);
VR.UR = new VR('UR', 0x5552, 12, 0x20);
VR.US = new VR('US', 0x5553, 8, 0);
VR.UT = new VR('UT', 0x5554, 12, 0x20);
VR.UV = new VR('UV', 0x5556, 12, 0);
VR.values = [
    VR.AE,
    VR.AS,
    VR.AT,
    VR.CS,
    VR.DA,
    VR.DS,
    VR.DT,
    VR.FD,
    VR.FL,
    VR.IS,
    VR.LO,
    VR.LT,
    VR.OB,
    VR.OD,
    VR.OF,
    VR.OL,
    VR.OV,
    VR.OW,
    VR.PN,
    VR.SH,
    VR.SL,
    VR.SQ,
    VR.SS,
    VR.ST,
    VR.SV,
    VR.TM,
    VR.UC,
    VR.UI,
    VR.UL,
    VR.UN,
    VR.UR,
    VR.US,
    VR.UT,
    VR.UV,
];
VR.map = VR.values.reduce((m, vr) => {
    m.set(vr.code, vr);
    return m;
}, new Map());
exports.VR = VR;
//# sourceMappingURL=vr.js.map